//
//  DataMonitorController.m
//  GlowWorm
//
//  Created by Curtis Jones on 2007.02.08.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "DataMonitorController.h"

#import <Common.h>
#import <Logger.h>
#import <GlowWorm.h>
#import <GlowWormStat.h>
#import <GlowWormPlugin.h>





@implementation DataMonitorController





///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark initalization functions





- (id)initWithStatId:(NSNumber *)aStatId
{
	self = [super init];
	
#ifdef STANDALONE
	[GlowWorm getInstance];
#endif
	
	if (self) {
		mStatId = [aStatId retain];
		mHault = FALSE;
		
		if (![NSBundle loadNibNamed:@"DataMonitor" owner:self])  {
			NSLog(@"Failed to load DataMonitor.nib");
			[self release];
			return nil;
		}
	}
	
	return self;
}

- (void)dealloc
{
	[super dealloc];
}

- (void)awakeFromNib
{
	GWLog(@"%s", __PRETTY_FUNCTION__);
	
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	// load our sub-menu
	{
		[mMonitorWin setOpaque:FALSE];
		[mMonitorWin setBackgroundColor:[NSColor colorWithDeviceRed:0.0 green:0.0 blue:0.0 alpha:0.3]];
//	[mMonitorWin setMovableByWindowBackground:TRUE];
		[mMonitorWin setMovableByWindowBackground:FALSE];
//	[mMonitorWin setShowsResizeIndicator:TRUE];
		
		mMonitorView->mStatId = [mStatId retain];
	}
	
#ifndef STANDALONE
	[NSThread detachNewThreadSelector:@selector(updateMonitorsLoop) toTarget:self withObject:nil];
#endif
	
	[pool release];
}

- (void)stop
{
	mHault = TRUE;
	[mMonitorWin close];
}





///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark miscellaneous functions





- (void)addSample:(GlowWormStat *)aStat
{
	[mMonitorView addSample:aStat];
}





///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark kext miscellaneous functions





- (void)updateMonitorsLoop
{
	NSAutoreleasePool * apool = [[NSAutoreleasePool alloc] init];
	
	while (!mHault)
	{
		NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
		
	//GWLog(@"%s.. [0x%08lx] setNeedsDisplay", __PRETTY_FUNCTION__, self);
		
		[mMonitorView setNeedsDisplay:TRUE];
		
		sleep(1);
		
		[pool release];
	}
	
	[apool release];
}

@end
